From 27e3d14acab32e477ce3c2c09887fe8fb6d8fdbe Mon Sep 17 00:00:00 2001
From: manisha <manisha_kanyal.scsebtech@galgotiasuniversity.edu.in>
Date: May 26 2021 12:21:32 +0000
Subject: retry for a failure


show alert when retrying and retry button on failure

Moved retryLimit to Project Constants.

styling fixed

Masthead implementation change

---

diff --git a/.prettierrc b/.prettierrc
new file mode 100644
index 0000000..95886f1
--- /dev/null
+++ b/.prettierrc
@@ -0,0 +1,7 @@
+{
+  "tabWidth": 2,
+  "useTabs": false,
+  "jsxBracketSameLine": true,
+  "semi": false,
+  "printWidth": 99
+}
diff --git a/src/actions/reduxActions.js b/src/actions/reduxActions.js
index 80a3461..8b9d0c1 100644
--- a/src/actions/reduxActions.js
+++ b/src/actions/reduxActions.js
@@ -1,43 +1,86 @@
-import ActionTypes from '../constants';
+import ActionTypes from "../constants"
+import {
+  API_CALL_STATUS_VALUES,
+  MAX_RETRY_LIMIT,
+  FIRST_RETRY_GAP,
+} from "../constants/ProjectConstants"
 
-export const loadDataResp = payload => ({
-    type: ActionTypes.LOAD_DATA_RESP,
-    payload: payload
+export const loadDataResp = (payload) => ({
+  type: ActionTypes.LOAD_DATA_RESP,
+  payload: payload,
 })
 
-export const loadData = payload => dispatch => {
-    dispatch({
-        type: ActionTypes.LOAD_DATA,
-        payload: payload
-    });
-
-    fetch(window.env.ORACULUM_API_URL_v1 + "landing_page")
-    .then(blob => blob.json())
-    .then(data => {
-        dispatch(loadDataResp(data))
+export const loadData = (
+  payload,
+  retryLimit = MAX_RETRY_LIMIT,
+  secondsToWait = FIRST_RETRY_GAP
+) => (dispatch) => {
+  dispatch({
+    type: ActionTypes.LOAD_DATA,
+    payload: payload,
+  })
+  dispatch(updateLandingPageApiCallStatus(API_CALL_STATUS_VALUES.STARTED))
+  fetch(window.env.ORACULUM_API_URL_v1 + "landing_page")
+    .then((blob) => blob.json())
+    .then((data) => {
+      dispatch(loadDataResp(data))
+      dispatch(updateLandingPageApiCallStatus(API_CALL_STATUS_VALUES.FULFILLED))
     })
     .catch((error) => {
-        console.error('Error:', error);
-    });
+      if (retryLimit > 0) {
+        dispatch(updateLandingPageApiCallStatus(API_CALL_STATUS_VALUES.RETRYING))
+        console.log("Failed to fetch, retrying", MAX_RETRY_LIMIT - retryLimit)
+        window.setTimeout(() => {
+          dispatch(loadData(payload, retryLimit - 1, secondsToWait * 2))
+        }, secondsToWait * 1000)
+      } else {
+        dispatch(updateLandingPageApiCallStatus(API_CALL_STATUS_VALUES.FAILED))
+        console.error("Error:", error)
+      }
+    })
 }
 
-export const loadWizardDataResp = payload => ({
-    type: ActionTypes.LOAD_WIZARD_DATA_RESP,
-    payload: payload
+export const loadWizardDataResp = (payload) => ({
+  type: ActionTypes.LOAD_WIZARD_DATA_RESP,
+  payload: payload,
 })
 
-export const loadWizardData = payload => dispatch => {
-    dispatch({
-        type: ActionTypes.LOAD_WIZARD_DATA,
-        payload: payload
-    });
-
-    fetch(window.env.ORACULUM_API_URL_v1 + "actions/all")
-    .then(blob => blob.json())
-    .then(data => {
-        dispatch(loadWizardDataResp(data))
+export const loadWizardData = (
+  payload,
+  retryLimit = MAX_RETRY_LIMIT,
+  secondsToWait = FIRST_RETRY_GAP
+) => (dispatch) => {
+  dispatch({
+    type: ActionTypes.LOAD_WIZARD_DATA,
+    payload: payload,
+  })
+  dispatch(updateWizardApiCallStatus(API_CALL_STATUS_VALUES.STARTED))
+  fetch(window.env.ORACULUM_API_URL_v1 + "actions/all")
+    .then((blob) => blob.json())
+    .then((data) => {
+      dispatch(loadWizardDataResp(data))
+      dispatch(updateWizardApiCallStatus(API_CALL_STATUS_VALUES.FULFILLED))
     })
     .catch((error) => {
-        console.error('Error:', error);
-    });
+      if (retryLimit > 0) {
+        dispatch(updateWizardApiCallStatus(API_CALL_STATUS_VALUES.RETRYING))
+        console.log("Failed to fetch, retrying", MAX_RETRY_LIMIT - retryLimit)
+        window.setTimeout(() => {
+          dispatch(loadWizardData(payload, retryLimit - 1, secondsToWait * 2))
+        }, secondsToWait * 1000)
+      } else {
+        dispatch(updateWizardApiCallStatus(API_CALL_STATUS_VALUES.FAILED))
+        console.error("Error:", error)
+      }
+    })
 }
+
+export const updateLandingPageApiCallStatus = (status) => ({
+  type: ActionTypes.UPDATE_LANDING_PAGE_API_CALL_STATUS,
+  payload: status,
+})
+
+export const updateWizardApiCallStatus = (status) => ({
+  type: ActionTypes.UPDATE_WIZARD_API_CALL_STATUS,
+  payload: status,
+})
diff --git a/src/constants/ProjectConstants.js b/src/constants/ProjectConstants.js
new file mode 100644
index 0000000..546ab63
--- /dev/null
+++ b/src/constants/ProjectConstants.js
@@ -0,0 +1,10 @@
+export const API_CALL_STATUS_VALUES = {
+  NOT_STARTED: "NOT_STARTED",
+  STARTED: "STARTED",
+  RETRYING: "RETRYING",
+  FAILED: "FAILED",
+  FULFILLED: "FULFILLED",
+}
+
+export const MAX_RETRY_LIMIT = 5
+export const FIRST_RETRY_GAP = 5 //in seconds
diff --git a/src/constants/Routes.js b/src/constants/Routes.js
new file mode 100644
index 0000000..16e4248
--- /dev/null
+++ b/src/constants/Routes.js
@@ -0,0 +1,4 @@
+export const ROUTE = {
+  LANDING_PAGE: "/",
+  WIZARD_PAGE: "/wizard",
+}
diff --git a/src/constants/index.js b/src/constants/index.js
index c6bfe99..f1b837e 100644
--- a/src/constants/index.js
+++ b/src/constants/index.js
@@ -1,6 +1,8 @@
 export default {
-    LOAD_DATA: 'LOAD_DATA',
-    LOAD_DATA_RESP: 'LOAD_DATA_RESP',
-    LOAD_WIZARD_DATA: 'LOAD_WIZARD_DATA',
-    LOAD_WIZARD_DATA_RESP: 'LOAD_WIZARD_DATA_RESP',
+  LOAD_DATA: "LOAD_DATA",
+  LOAD_DATA_RESP: "LOAD_DATA_RESP",
+  LOAD_WIZARD_DATA: "LOAD_WIZARD_DATA",
+  LOAD_WIZARD_DATA_RESP: "LOAD_WIZARD_DATA_RESP",
+  UPDATE_LANDING_PAGE_API_CALL_STATUS: "UPDATE_LANDING_PAGE_API_CALL_STATUS",
+  UPDATE_WIZARD_API_CALL_STATUS: "UPDATE_WIZARD_API_CALL_STATUS",
 }
diff --git a/src/index.js b/src/index.js
index 35f417c..9c2349b 100644
--- a/src/index.js
+++ b/src/index.js
@@ -1,36 +1,39 @@
-import React from 'react';
-import ReactDOM from 'react-dom';
+import React from "react"
+import ReactDOM from "react-dom"
 
-import './index.css';
+import "./index.css"
 //import 'bootstrap/dist/css/bootstrap.min.css';
 
-import 'typeface-open-sans'
+import "typeface-open-sans"
 
-import App from './App';
-import * as serviceWorker from './serviceWorker';
+import App from "./App"
+import * as serviceWorker from "./serviceWorker"
 
-import { createStore, applyMiddleware } from 'redux'
-import thunkMiddleware from 'redux-thunk'
-import { createLogger } from 'redux-logger'
-import { Provider } from 'react-redux'
-import reducer from './reducers'
+import { createStore, applyMiddleware, compose } from "redux"
+import thunkMiddleware from "redux-thunk"
+import { createLogger } from "redux-logger"
+import { Provider } from "react-redux"
+import reducer from "./reducers"
 
-const loggerMiddleware = createLogger();
-const store = createStore(reducer, applyMiddleware(
-  thunkMiddleware,
-  loggerMiddleware
-));
+const loggerMiddleware = createLogger()
+
+const composeEnhancers = window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ || compose
+
+const store = createStore(
+  reducer,
+  composeEnhancers(applyMiddleware(thunkMiddleware, loggerMiddleware))
+)
 
 ReactDOM.render(
-    <React.StrictMode>
-      <Provider store={store}>
-        <App />
-      </Provider>
-    </React.StrictMode>,
-    document.getElementById('root')
-  );
+  <React.StrictMode>
+    <Provider store={store}>
+      <App />
+    </Provider>
+  </React.StrictMode>,
+  document.getElementById("root")
+)
 
 // If you want your app to work offline and load faster, you can change
 // unregister() to register() below. Note this comes with some pitfalls.
 // Learn more about service workers: http://bit.ly/CRA-PWA
-serviceWorker.unregister();
+serviceWorker.unregister()
diff --git a/src/landingpage/LandingPage.js b/src/landingpage/LandingPage.js
index 5ae38fe..ace8b3a 100644
--- a/src/landingpage/LandingPage.js
+++ b/src/landingpage/LandingPage.js
@@ -21,7 +21,9 @@ class LandingPage extends Component {
     let enabled_components = this.cookies.get("landingpage_enabled_components")
     if (enabled_components === undefined) {
       enabled_components = this.available_components.slice()
-      this.cookies.set("landingpage_enabled_components", enabled_components, { path: "/" })
+      this.cookies.set("landingpage_enabled_components", enabled_components, {
+        path: "/",
+      })
     }
     this.state = {
       blockerbugs: {},
@@ -57,7 +59,9 @@ class LandingPage extends Component {
       enabled_components.push(name)
       enabled_components = this.available_components.filter((c) => enabled_components.includes(c))
     }
-    this.cookies.set("landingpage_enabled_components", enabled_components, { path: "/" })
+    this.cookies.set("landingpage_enabled_components", enabled_components, {
+      path: "/",
+    })
     this.setState({ enabled_components: enabled_components })
     e.preventDefault()
   }
@@ -88,8 +92,9 @@ class LandingPage extends Component {
         ))}
       </Row>
     ))
+
     return (
-      <Layout loading={this.props.stable === 0}>
+      <Layout apiCallStatus={this.props.api_call_status}>
         <div className="bluebox">
           <Container>
             <Row>
diff --git a/src/layout/Layout.js b/src/layout/Layout.js
index 17b4499..653e4ba 100644
--- a/src/layout/Layout.js
+++ b/src/layout/Layout.js
@@ -1,14 +1,15 @@
 import React, { Component } from "react"
 import Masthead from "./Masthead"
 import Footer from "./Footer"
+import { API_CALL_STATUS_VALUES } from "../constants/ProjectConstants"
 
 class Layout extends Component {
   render() {
-    const { loading } = this.props
+    const { apiCallStatus } = this.props
     return (
       <div>
-        <Masthead loading={loading} />
-        {loading ? null : this.props.children}
+        <Masthead />
+        {apiCallStatus !== API_CALL_STATUS_VALUES.FULFILLED ? null : this.props.children}
         <Footer />
       </div>
     )
diff --git a/src/layout/Masthead.js b/src/layout/Masthead.js
index a48e1d8..018db74 100644
--- a/src/layout/Masthead.js
+++ b/src/layout/Masthead.js
@@ -1,28 +1,89 @@
-import React, { Component } from "react"
-import { Link } from "react-router-dom"
-import { Container, NavbarBrand, Navbar } from "reactstrap"
-
+import React from "react"
+import { Link, useLocation } from "react-router-dom"
+import { Container, NavbarBrand, Navbar, Button } from "reactstrap"
+import { API_CALL_STATUS_VALUES } from "../constants/ProjectConstants"
+import { ROUTE } from "../constants/Routes"
 import logo from "./logo.png"
+import { loadData, loadWizardData } from "../actions/reduxActions"
+import { shallowEqual, useDispatch, useSelector } from "react-redux"
 
-class Masthead extends Component {
-  render() {
-    return (
-      <Navbar className="masthead">
-        <Container>
-          <NavbarBrand tag="div">
-            <Link to="/">
-              <img src={logo} alt="" />
-            </Link>
-          </NavbarBrand>
-          {this.props.loading ? (
-            <span className="fa-lg">
-              <i class="fas fa-spinner fa-pulse"></i>
-            </span>
-          ) : null}
-        </Container>
-      </Navbar>
-    )
+const selectWizardFromStore = (state) => state.wizard.api_call_status
+const selectLandingPageFromStore = (state) => state.landing_page.api_call_status
+
+const Masthead = () => {
+  const location = useLocation()
+  const dispatch = useDispatch()
+
+  const wizard_api_call_status = useSelector(selectWizardFromStore, shallowEqual)
+  const landing_page_api_call_status = useSelector(selectLandingPageFromStore, shallowEqual)
+
+  const api_call_status = () => {
+    if (ROUTE.LANDING_PAGE === location.pathname) {
+      return landing_page_api_call_status
+    } else if (ROUTE.WIZARD_PAGE === location.pathname) {
+      return wizard_api_call_status
+    } else {
+      return null
+    }
   }
+
+  const getRetryFunction = () => {
+    if (ROUTE.LANDING_PAGE === location.pathname) {
+      return loadData
+    } else if (ROUTE.WIZARD_PAGE === location.pathname) {
+      return loadWizardData
+    } else {
+      return null
+    }
+  }
+
+  const handleRetry = () => {
+    const retryFn = getRetryFunction()
+    dispatch(retryFn())
+  }
+
+  return (
+    <Navbar className="masthead">
+      <Container>
+        <NavbarBrand tag="div">
+          <Link to="/">
+            <img src={logo} alt="" />
+          </Link>
+        </NavbarBrand>
+        <div>
+          {api_call_status() === API_CALL_STATUS_VALUES.STARTED ||
+          api_call_status() === API_CALL_STATUS_VALUES.RETRYING ? (
+            <>
+              {api_call_status() === API_CALL_STATUS_VALUES.RETRYING && (
+                <>
+                  <span className="fa-lg mr-1 text-danger">
+                    <i class="fas fa-exclamation-triangle"></i>
+                  </span>
+                  <span className="mr-3">Retrying</span>
+                </>
+              )}
+              <span className="fa-lg mr-3">
+                <i className="fas fa-spinner fa-pulse"></i>
+              </span>
+            </>
+          ) : null}
+          {api_call_status() === API_CALL_STATUS_VALUES.FAILED && (
+            <>
+              <span className="fa-lg mr-1">
+                <i class="fas fa-exclamation-triangle"></i>
+              </span>
+              <span className="mr-3">Failed to fetch data!</span>
+              {handleRetry && (
+                <Button outline color="danger" size="sm" onClick={handleRetry}>
+                  Retry
+                </Button>
+              )}
+            </>
+          )}
+        </div>
+      </Container>
+    </Navbar>
+  )
 }
 
 export default Masthead
diff --git a/src/reducers/index.js b/src/reducers/index.js
index 5e628e0..5551055 100644
--- a/src/reducers/index.js
+++ b/src/reducers/index.js
@@ -10,11 +10,13 @@ const defaultState = {
     stable: 0,
     config_mode: false,
     enabled_components: ["events", "blockers", "minutes"],
+    api_call_status: null,
   },
   wizard: {
     actions: [],
     providers: [],
     all_actions: [],
+    api_call_status: null,
   },
 }
 
@@ -23,7 +25,10 @@ export default (state = defaultState, action) => {
     case ActionTypes.LOAD_DATA_RESP:
       return {
         ...state,
-        landing_page: action.payload,
+        landing_page: {
+          ...state.landing_page,
+          ...action.payload,
+        },
       }
 
     case ActionTypes.LOAD_WIZARD_DATA_RESP:
@@ -36,6 +41,22 @@ export default (state = defaultState, action) => {
         },
       }
 
+    case ActionTypes.UPDATE_WIZARD_API_CALL_STATUS:
+      return {
+        ...state,
+        wizard: {
+          ...state.wizard,
+          api_call_status: action.payload,
+        },
+      }
+    case ActionTypes.UPDATE_LANDING_PAGE_API_CALL_STATUS:
+      return {
+        ...state,
+        landing_page: {
+          ...state.landing_page,
+          api_call_status: action.payload,
+        },
+      }
     default:
       return {
         ...state,
diff --git a/src/wizard/Wizard.js b/src/wizard/Wizard.js
index a9ecb3e..86a8227 100644
--- a/src/wizard/Wizard.js
+++ b/src/wizard/Wizard.js
@@ -1,7 +1,6 @@
 import React, { Component } from "react"
 import WizardForm from "./WizardForm"
 import Layout from "../layout/Layout"
-import { oraculumApiUrl_v1 } from "../config"
 import Actions from "./Actions"
 import { Container, Row } from "reactstrap"
 
@@ -14,28 +13,24 @@ class Wizard extends Component {
     this.state = {
       actions: [],
     }
+    this.getData = this.getData.bind(this)
   }
 
-  componentDidMount() {
-    fetch(oraculumApiUrl_v1 + "actions/all")
-      .then((resp) => resp.json())
-      .then((data) => {
-        this.setState({
-          providers: data.providers,
-          all_actions: data.actions,
-        })
-      })
-
+  getData() {
     this.props.dispatch(loadWizardData())
   }
 
+  componentDidMount() {
+    this.getData()
+  }
+
   show_actions(actions) {
     this.setState({ actions })
   }
 
   render() {
     return (
-      <Layout>
+      <Layout apiCallStatus={this.props.api_call_status}>
         <div className="bluebox">
           <Container>
             <WizardForm
